Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 4901)
+++ palm/trunk/SOURCE/parin.f90	(revision 1)
@@ -116,366 +117,106 @@
 ! Description:
 ! ------------
-!> This subroutine reads variables controling the run from the NAMELIST files
-!>
-!> @todo: Revise max_pr_cs (profiles for chemistry)
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE parin
-
-
-    USE arrays_3d,                                                                                 &
-        ONLY:  pt_init, q_init, ref_state, s_init, sa_init, ug, u_init, v_init, vg
-
-    USE chem_modules
-
+! This subroutine reads variables controling the run from the NAMELIST files
+!------------------------------------------------------------------------------!
+
+    USE arrays_3d
+    USE averaging
     USE control_parameters
-
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log_barrierwait
-
-    USE grid_variables,                                                                            &
-        ONLY:  dx, dy
-
-    USE indices,                                                                                   &
-        ONLY:  nx, ny, nz
-
-    USE kinds
-
-    USE model_1d_mod,                                                                              &
-        ONLY:  damp_level_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
-
-    USE module_interface,                                                                          &
-        ONLY:  module_interface_parin
-
-    USE netcdf_interface,                                                                          &
-        ONLY:  netcdf_data_format, netcdf_deflate, netcdf_precision
-
+    USE grid_variables
+    USE indices
+    USE model_1d
     USE pegrid
-
-    USE pmc_interface,                                                                             &
-        ONLY:  nested_run, nesting_mode
-
-    USE profil_parameter,                                                                          &
-        ONLY:  cross_profiles, profile_columns, profile_rows
-
-    USE progress_bar,                                                                              &
-        ONLY :  progress_bar_disabled
-
-    USE read_restart_data_mod,                                                                     &
-        ONLY:  rrd_global
-
-    USE statistics,                                                                                &
-        ONLY:  hom, hom_sum, pr_palm, statistic_regions
-
-    USE turbulence_closure_mod,                                                                    &
-        ONLY:  rans_const_c, rans_const_sigma
-
+    USE profil_parameter
+    USE statistics
 
     IMPLICIT NONE
 
-    CHARACTER(LEN=100) ::  line  !< dummy string that contains the current line of the parameter
-                                 !< file
-
-    INTEGER(iwp) ::  global_id      !< process id with respect to MPI_COMM_WORLD
-    INTEGER(iwp) ::  global_procs   !< # of procs with respect to MPI_COMM_WORLD
-    INTEGER(iwp) ::  i              !<
-    INTEGER(iwp) ::  io_status      !< status after reading the namelist files
-
-
-    NAMELIST /initialization_parameters/  alpha_surface,                                           &
-                                          approximation,                                           &
-                                          bc_e_b,                                                  &
-                                          bc_lr,                                                   &
-                                          bc_ns,                                                   &
-                                          bc_p_b,                                                  &
-                                          bc_p_t,                                                  &
-                                          bc_pt_b,                                                 &
-                                          bc_pt_t,                                                 &
-                                          bc_q_b,                                                  &
-                                          bc_q_t,                                                  &
-                                          bc_s_b,                                                  &
-                                          bc_s_t,                                                  &
-                                          bc_uv_b,                                                 &
-                                          bc_uv_t,                                                 &
-                                          building_height,                                         &
-                                          building_length_x,                                       &
-                                          building_length_y,                                       &
-                                          building_wall_left,                                      &
-                                          building_wall_south,                                     &
-                                          calc_soil_moisture_during_spinup,                        &
-                                          call_psolver_at_all_substeps,                            &
-                                          canyon_height,                                           &
-                                          canyon_wall_left,                                        &
-                                          canyon_wall_south,                                       &
-                                          canyon_width_x,                                          &
-                                          canyon_width_y,                                          &
-                                          cfl_factor,                                              &
-                                          check_realistic_q,                                       &
-                                          cloud_droplets,                                          &
-                                          collective_wait,                                         &
-                                          complex_terrain,                                         &
-                                          conserve_volume_flow,                                    &
-                                          conserve_volume_flow_mode,                               &
-                                          constant_flux_layer,                                     &
-                                          coupling_start_time,                                     &
-                                          cycle_mg,                                                &
-                                          damp_level_1d,                                           &
-                                          data_output_during_spinup,                               &
-                                          dissipation_1d,                                          &
-                                          dp_external,                                             &
-                                          dp_level_b,                                              &
-                                          dp_smooth, dpdxy,                                        &
-                                          dt,                                                      &
-                                          dt_pr_1d,                                                &
-                                          dt_run_control_1d,                                       &
-                                          dt_spinup,                                               &
-                                          dx,                                                      &
-                                          dy,                                                      &
-                                          dz,                                                      &
-                                          dz_max,                                                  &
-                                          dz_stretch_factor,                                       &
-                                          dz_stretch_level,                                        &
-                                          dz_stretch_level_start,                                  &
-                                          dz_stretch_level_end,                                    &
-                                          e_init,                                                  &
-                                          e_min,                                                   &
-                                          end_time_1d,                                             &
-                                          ensemble_member_nr,                                      &
-                                          fft_method,                                              &
-                                          flux_input_mode,                                         &
-                                          flux_output_mode,                                        &
-                                          galilei_transformation,                                  &
-                                          humidity,                                                &
-                                          inflow_damping_height,                                   &
-                                          inflow_damping_width,                                    &
-                                          inflow_disturbance_begin,                                &
-                                          inflow_disturbance_end,                                  &
-                                          initializing_actions,                                    &
-                                          km_constant,                                             &
-                                          large_scale_forcing,                                     &
-                                          large_scale_subsidence,                                  &
-                                          latitude,                                                &
-                                          longitude,                                               &
-                                          loop_optimization,                                       &
-                                          lsf_exception,                                           &
-                                          masking_method,                                          &
-                                          mg_cycles,                                               &
-                                          mg_switch_to_pe0_level,                                  &
-                                          mixing_length_1d,                                        &
-                                          momentum_advec,                                          &
-                                          monotonic_limiter_z,                                     &
-                                          netcdf_precision,                                        &
-                                          neutral,                                                 &
-                                          ngsrb,                                                   &
-                                          nsor,                                                    &
-                                          nsor_ini,                                                &
-                                          nudging,                                                 &
-                                          nx,                                                      &
-                                          ny,                                                      &
-                                          nz,                                                      &
-                                          omega,                                                   &
-                                          omega_sor,                                               &
-                                          origin_date_time,                                        &
-                                          outflow_source_plane,                                    &
-                                          passive_scalar,                                          &
-                                          prandtl_number,                                          &
-                                          psolver,                                                 &
-                                          pt_damping_factor,                                       &
-                                          pt_damping_width,                                        &
-                                          pt_reference, pt_surface,                                &
-                                          pt_surface_heating_rate,                                 &
-                                          pt_surface_initial_change,                               &
-                                          pt_vertical_gradient,                                    &
-                                          pt_vertical_gradient_level,                              &
-                                          q_surface,                                               &
-                                          q_surface_initial_change,                                &
-                                          q_vertical_gradient,                                     &
-                                          q_vertical_gradient_level,                               &
-                                          random_generator,                                        &
-                                          random_heatflux,                                         &
-                                          rans_const_c,                                            &
-                                          rans_const_sigma,                                        &
-                                          rayleigh_damping_factor,                                 &
-                                          rayleigh_damping_height,                                 &
-                                          recycling_method_for_thermodynamic_quantities,           &
-                                          recycling_width,                                         &
-                                          reference_state,                                         &
-                                          residual_limit,                                          &
-                                          restart_data_format,                                     &
-                                          restart_data_format_input,                               &
-                                          restart_data_format_output,                              &
-                                          rotation_angle,                                          &
-                                          roughness_length,                                        &
-                                          s_surface,                                               &
-                                          s_surface_initial_change,                                &
-                                          s_vertical_gradient,                                     &
-                                          s_vertical_gradient_level,                               &
-                                          scalar_advec,                                            &
-                                          scalar_rayleigh_damping,                                 &
-                                          spinup_time,                                             &
-                                          spinup_pt_amplitude,                                     &
-                                          spinup_pt_mean,                                          &
-                                          statistic_regions,                                       &
-                                          subs_vertical_gradient,                                  &
-                                          subs_vertical_gradient_level,                            &
-                                          surface_heatflux,                                        &
-                                          surface_pressure,                                        &
-                                          surface_scalarflux,                                      &
-                                          surface_waterflux,                                       &
-                                          timestep_scheme,                                         &
-                                          topography,                                              &
-                                          topography_grid_convention,                              &
-                                          top_heatflux,                                            &
-                                          top_momentumflux_u,                                      &
-                                          top_momentumflux_v,                                      &
-                                          top_scalarflux,                                          &
-                                          transpose_compute_overlap,                               &
-                                          tunnel_height,                                           &
-                                          tunnel_length,                                           &
-                                          tunnel_wall_depth,                                       &
-                                          tunnel_width_x,                                          &
-                                          tunnel_width_y,                                          &
-                                          turbulence_closure,                                      &
-                                          turbulent_inflow,                                        &
-                                          turbulent_outflow,                                       &
-                                          u_bulk,                                                  &
-                                          u_profile,                                               &
-                                          ug_surface,                                              &
-                                          ug_vertical_gradient,                                    &
-                                          ug_vertical_gradient_level,                              &
-                                          use_fixed_date,                                          &
-                                          use_fixed_time,                                          &
-                                          use_free_convection_scaling,                             &
-                                          use_ug_for_galilei_tr,                                   &
-                                          use_subsidence_tendencies,                               &
-                                          use_surface_fluxes,                                      &
-                                          use_top_fluxes,                                          &
-                                          use_upstream_for_tke,                                    &
-                                          uv_heights,                                              &
-                                          v_bulk,                                                  &
-                                          v_profile,                                               &
-                                          vdi_checks,                                              &
-                                          vg_surface,                                              &
-                                          vg_vertical_gradient,                                    &
-                                          vg_vertical_gradient_level,                              &
-                                          wall_adjustment,                                         &
-                                          wall_heatflux,                                           &
-                                          wall_humidityflux,                                       &
-                                          wall_scalarflux,                                         &
-                                          y_shift,                                                 &
-                                          zeta_max,                                                &
-                                          zeta_min,                                                &
-                                          z0h_factor
-
-    NAMELIST /runtime_parameters/  averaging_interval,                                             &
-                                   averaging_interval_pr,                                          &
-                                   cpu_log_barrierwait,                                            &
-                                   create_disturbances,                                            &
-                                   cross_profiles,                                                 &
-                                   data_output,                                                    &
-                                   data_output_2d_on_each_pe,                                      &
-                                   data_output_masks,                                              &
-                                   data_output_pr,                                                 &
-                                   debug_output,                                                   &
-                                   debug_output_timestep,                                          &
-                                   disturbance_amplitude,                                          &
-                                   disturbance_energy_limit,                                       &
-                                   disturbance_level_b,                                            &
-                                   disturbance_level_t,                                            &
-                                   do2d_at_begin,                                                  &
-                                   do3d_at_begin,                                                  &
-                                   dt,                                                             &
-                                   dt_averaging_input,                                             &
-                                   dt_averaging_input_pr,                                          &
-                                   dt_coupling,                                                    &
-                                   dt_data_output,                                                 &
-                                   dt_data_output_av,                                              &
-                                   dt_disturb,                                                     &
-                                   dt_domask,                                                      &
-                                   dt_dopr,                                                        &
-                                   dt_dopr_listing,                                                &
-                                   dt_dots,                                                        &
-                                   dt_do2d_xy,                                                     &
-                                   dt_do2d_xz,                                                     &
-                                   dt_do2d_yz,                                                     &
-                                   dt_do3d,                                                        &
-                                   dt_max,                                                         &
-                                   dt_restart,                                                     &
-                                   dt_run_control,                                                 &
-                                   end_time,                                                       &
-                                   force_print_header,                                             &
-                                   mask_k_over_surface,                                            &
-                                   mask_scale_x,                                                   &
-                                   mask_scale_y,                                                   &
-                                   mask_scale_z,                                                   &
-                                   mask_x,                                                         &
-                                   mask_y,                                                         &
-                                   mask_z,                                                         &
-                                   mask_x_loop,                                                    &
-                                   mask_y_loop,                                                    &
-                                   mask_z_loop,                                                    &
-                                   netcdf_data_format,                                             &
-                                   netcdf_deflate,                                                 &
-                                   normalizing_region,                                             &
-                                   npex,                                                           &
-                                   npey,                                                           &
-                                   nz_do3d,                                                        &
-                                   profile_columns,                                                &
-                                   profile_rows,                                                   &
-                                   restart_time,                                                   &
-                                   section_xy,                                                     &
-                                   section_xz,                                                     &
-                                   section_yz,                                                     &
-                                   restart_data_format,                                            &
-                                   restart_data_format_input,                                      &
-                                   restart_data_format_output,                                     &
-                                   skip_time_data_output,                                          &
-                                   skip_time_data_output_av,                                       &
-                                   skip_time_dopr,                                                 &
-                                   skip_time_do2d_xy,                                              &
-                                   skip_time_do2d_xz,                                              &
-                                   skip_time_do2d_yz,                                              &
-                                   skip_time_do3d,                                                 &
-                                   skip_time_domask,                                               &
-                                   synchronous_exchange,                                           &
-                                   termination_time_needed
-
-    NAMELIST /envpar/  host,                                                                       &
-                       maximum_cpu_time_allowed,                                                   &
-                       maximum_parallel_io_streams,                                                &
-                       progress_bar_disabled,                                                      &
-                       read_svf,                                                                   &
-                       revision,                                                                   &
-                       run_identifier,                                                             &
-                       tasks_per_node,                                                             &
-                       write_binary,                                                               &
-                       write_svf
-
-!
-!-- First read values of environment variables (this NAMELIST file is generated by palmrun)
-    CALL location_message( 'reading environment parameters from ENVPAR', 'start' )
-
-    OPEN( 90, FILE='ENVPAR', STATUS='OLD', FORM='FORMATTED', IOSTAT=io_status )
-
-    IF ( io_status /= 0 )  THEN
-       message_string = 'local file ENVPAR not found' //                                           &
-                        '&some variables for steering may not be properly set'
-       CALL message( 'parin', 'PA0276', 0, 1, 0, 6, 0 )
-    ELSE
-       READ( 90, envpar, IOSTAT=io_status )
-       IF ( io_status < 0 )  THEN
-          message_string = 'no envpar-NAMELIST found in local file '  //                           &
-                           'ENVPAR& or some variables for steering may not be properly set'
-          CALL message( 'parin', 'PA0278', 0, 1, 0, 6, 0 )
-       ELSEIF ( io_status > 0 )  THEN
-          message_string = 'errors in local file ENVPAR' //                                        &
-                           '&some variables for steering may not be properly set'
-          CALL message( 'parin', 'PA0277', 0, 1, 0, 6, 0 )
-       ENDIF
-       CLOSE( 90 )
-    ENDIF
-
-    CALL location_message( 'reading environment parameters from ENVPAR', 'finished' )
-
-    CALL location_message( 'reading NAMELIST parameters from PARIN', 'start' )
+    INTEGER ::  idum
+
+
+    NAMELIST /inipar/  adjust_mixing_length, alpha_surface, bc_e_b, bc_lr, &
+                       bc_ns, bc_p_b, bc_p_t, bc_pt_b, bc_pt_t, bc_q_b, &
+                       bc_q_t,bc_s_b, bc_s_t, bc_uv_b, bc_uv_t, &
+                       building_height, building_length_x, building_length_y, &
+                       building_wall_left, building_wall_south, &
+                       cloud_droplets, cloud_physics, conserve_volume_flow, &
+                       cut_spline_overshoot, damp_level_1d, dissipation_1d, &
+                       dt, dt_pr_1d, dt_run_control_1d, dx, dy, dz, dz_max, &
+                       dz_stretch_factor, dz_stretch_level, e_min, &
+                       end_time_1d, fft_method, galilei_transformation, &
+                       grid_matching, inflow_disturbance_begin, &
+                       inflow_disturbance_end, initializing_actions, &
+                       km_constant, km_damp_max, long_filter_factor, &
+                       mixing_length_1d, moisture, momentum_advec, &
+                       netcdf_precision, npex, npey, nsor_ini, nx, ny, nz, &
+                       omega, outflow_damping_width, overshoot_limit_e, &
+                       overshoot_limit_pt, overshoot_limit_u, &
+                       overshoot_limit_v, overshoot_limit_w, passive_scalar, &
+                       phi, prandtl_layer, precipitation, pt_surface, &
+                       pt_surface_initial_change, pt_vertical_gradient, &
+                       pt_vertical_gradient_level, q_surface, &
+                       q_surface_initial_change, q_vertical_gradient, &
+                       q_vertical_gradient_level, radiation, random_generator, &
+                       random_heatflux, rif_max, rif_min, roughness_length, &
+                       scalar_advec, statistic_regions, surface_heatflux, &
+                       surface_pressure, surface_scalarflux, surface_waterflux,&
+                       s_surface, s_surface_initial_change, &
+                       s_vertical_gradient, s_vertical_gradient_level, &
+                       timestep_scheme, topography, ug_surface, &
+                       ug_vertical_gradient, ug_vertical_gradient_level, &
+                       ups_limit_e, ups_limit_pt, ups_limit_u, ups_limit_v, &
+                       ups_limit_w, use_surface_fluxes, use_ug_for_galilei_tr, &
+                       use_upstream_for_tke, vg_surface, vg_vertical_gradient, &
+                       vg_vertical_gradient_level, wall_adjustment, &
+                       wall_heatflux
+
+
+    NAMELIST /d3par/   averaging_interval,  averaging_interval_pr, &
+                       call_psolver_at_all_substeps, cfl_factor, &
+                       create_disturbances, cross_normalized_x, &
+                       cross_normalized_y, cross_profiles, cross_ts_uymax, &
+                       cross_ts_uymin, cross_xtext, cycle_mg, data_output, &
+                       data_output_format, data_output_pr, data_output_ts, &
+                       data_output_2d_on_each_pe, disturbance_amplitude, &
+                       disturbance_energy_limit, disturbance_level_b, &
+                       disturbance_level_t, do2d_at_begin, do3d_at_begin, &
+                       do3d_compress, do3d_comp_prec, dt, dt_averaging_input, &
+                       dt_averaging_input_pr, dt_data_output, &
+                       dt_data_output_av, dt_disturb, dt_dopr, &
+                       dt_dopr_listing, dt_dots, dt_do2d_xy, dt_do2d_xz, &
+                       dt_do2d_yz, dt_do3d, dt_restart, dt_run_control, &
+                       end_time, force_print_header, mg_cycles, &
+                       mg_switch_to_pe0_level, netcdf_64bit, ngsrb, &
+                       normalizing_region, nsor, nz_do3d, omega_sor, &
+                       prandtl_number, profile_columns, profile_rows, psolver, &
+                       rayleigh_damping_factor, rayleigh_damping_height, &
+                       residual_limit, restart_time, section_xy, section_xz, &
+                       section_yz, skip_time_data_output, &
+                       skip_time_data_output_av, skip_time_dopr, &
+                       skip_time_dosp, skip_time_do2d_xy, skip_time_do2d_xz, &
+                       skip_time_do2d_yz, skip_time_do3d, &
+                       termination_time_needed, use_prior_plot1d_parameters, &
+                       z_max_do1d, z_max_do1d_normalized, z_max_do2d
+
+
+    NAMELIST /envpar/  host, maximum_cpu_time_allowed, run_identifier, &
+                       tasks_per_node, write_binary
+
+
+#if defined( __parallel )
+!
+!-- Preliminary determination of processor-id which is needed here to open the
+!-- input files belonging to the corresponding processor and to produce
+!-- messages by PE0 only (myid and myid_char are later determined in
+!-- init_pegrid)
+    CALL MPI_COMM_RANK( comm_palm, myid, ierr )
+    WRITE (myid_char,'(''_'',I4.4)')  myid
+!
+!-- Since on IBM machines the process rank may be changed when the final
+!-- communicator is defined, save the preliminary processor-id for opening
+!-- the binary output file for restarts (unit 14), because otherwise
+!-- a mismatch occurs when reading this file in the next job
+    myid_char_14 = myid_char
+#endif
 
 !
